; Entry point (16514) - Find and print the next entry.

4082 1864      JR      $40E8	; Jump ahead to find and print the next entry.

; Program variables.

4084 D144      DEFW    $44D1	; Holds the position to search next.
4086 76        DEFB    $76	; Holds a flag indicating whether there is another entry in the current Data REM.
4087 15        DEFB    $15	; holds the length of the entry found.
4088 01	       DEFB    $01	; Holds counter specifying the entry to find ($01=Next entry).

; Entry point (16521) - Initialise serach parameters.

4089 21F640    LD      HL,$40F6	; Point to the initial search position.
408c 228440    LD      ($4084),HL

408f 3E00      LD      A,$00
4091 328640    LD      ($4086),A; Indicate to search multiple REM statements.

4094 3C        INC     A
4095 328840    LD      ($4088),A; Indicate to return the next entry found.
4098 C9        RET

; Find the next entry.

4099 3A8640    LD      A,($4086); Fetch the flag indicating whether there is another entry in the current Data REM.
409c FE0B      CP      $0B	; Is there the start of another entry?
409e 2009      JR      NZ,$40A9	; Jump if not to search for a new Data REM.

; There is another entry within the current Data REM.

40A0 2A8440    LD      HL,($4084); Fetch the search address.
40A3 23        INC     HL	; Advance to the next address.
40A4 228440    LD      ($4084),HL; Store the new search address.

40A7 181E      JR      $40C7			; Jump ahead to continue.

; Find a new Data REM statement.

40A9 ED4B0440  LD      BC,(RAMTOP); Set the maximum length to search (this should really be RAMTOP-$40FD).

; Enter a loop to search for a Data REM statement.

40AD 78        LD      A,B	; Fetch the high byte of the memory length counter.
40AE FE00      CP      $00	; Has all memory been searched?
40B0 2002      JR      NZ,$40B4	; Jump ahead if not.

; The end of memory has been reached without finding a new Data REM
statement.

40B2 CF        RST     $08	; Generate a BASIC error report.
40B3 1A        DEFB    $1A	; Error report 'R' = Data REM not found.

; Find a REM statement

40B4 3EEA      LD      A,$EA	; A 'REM' character.
40B6 2A8440    LD      HL,($4084); The start location to search from.
40B9 EDB1      CPIR    		; Search for a 'REM' byte.
40BB 228440    LD      ($4084),HL; Save the address after the 'REM' as the location to search from next time.

; A REM statement has been found.

40BE 3E0B      LD      A,$0B	; A quote character.
40C0 BE        CP      (HL)	; Is there a quote after the REM, i.e. is it a Data REM?
40C1 20EA      JR      NZ,$40AD	; Jump if not to continue searching.

; A Data REM has been found.

40C3 23        INC     HL	; Point to the first character of the entry.
40C4 228440    LD      ($4084),HL; Save the new search position.

; Count number of characters within the entry (maximum length of 64 characters).

40C7 110000    LD      DE,$0000	; Holds a count of the number of characters in the entry.
40CA 0640      LD      B,$40	; The maximum number of characters expected.
40CC 3E0B      LD      A,$0B	; A quote character, which marks the end of the entry.

; Enter a loop to count the characters within the entry.

40CE BE        CP      (HL)	; Has the end of the entry been reached?
40CF 2806      JR      Z,$40D7	; Jump ahead if so.

40D1 13        INC     DE	; Increment the entry length count.
40D2 23        INC     HL	; Point to the next character within the entry.
40D3 10F9      DJNZ    $40CE	; Loop back to check the next character.

; The end of the entry was not found within the maximum entry length.

40D5 CF        RST     $08	; Generate a BASIC error report.
40D6 19        DEFB    $19	; Error report 'Q' = Entry too long.

; The end of the entry has been found.

40D7 7B        LD      A,E	; Fetch the entry length.
40D8 328740    LD      ($4087),A; Store the entry length.

40DB ED5B8440  LD      DE,($4084); Fetch the start of the entry.

40DF 23        INC     HL	; Advance to the next location, which could be the start of another entry.
40E0 228440    LD      ($4084),HL; Store the next search position.

40E3 7E        LD      A,(HL)	; Fetch the next character at the new
position.
40E4 328640    LD      ($4086),A; Save as a flag indictaing whether there is another entry within the current Data REM.
40E7 C9        RET

; Find and print the nth entry (which will always be the first entry).

40E8 3A8840    LD      A,($4088); Fetch the entry search counter.
40EB 47        LD      B,A	; Transfer to B.

; Enter a loop to find the nth entry (which will always be the first entry).

40EC C5        PUSH    BC	; Save the entry counter.
40ED CD9940    CALL    $4099	; Find the next entry.
40F0 C1        POP     BC	; Retrieve the entry counter.
40F1 10F9      DJNZ    $40E7	; Loop back until the required entry has been reached.

; Print the entry.

40F3 3A8740    LD      A,($4087); Fetch the length of the entry.
40F6 4F        LD      C,A	; Transfer the entry length into BC.
40F7 0600      LD      B,$00

40F9 CD6B0B    CALL    $0B6B	; Call PR_STR-4 within the ROM to print the string. DE=Address, BC=Length.
40FC C9        RET

